"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var Stack_1 = require("./Stack");
var SPIN_CONFIG_NAME = '.spinrc.json';
var ConfigRc = (function () {
    function ConfigRc(spin, plugins, argv) {
        var pkg = spin.require('./package.json');
        var config = argv.c
            ? JSON.parse(fs.readFileSync(spin.require.resolve(argv.c)).toString())
            : pkg.spin ? pkg.spin : JSON.parse(fs.readFileSync(spin.require.resolve(SPIN_CONFIG_NAME)).toString());
        if (typeof config === 'string' || (typeof config === 'object' && config.constructor === Array)) {
            config = {
                builders: (_a = {},
                    _a[pkg.name] = config,
                    _a)
            };
        }
        config.options = config.options || {};
        var builders = {};
        var _b = config.options, stack = _b.stack, options = __rest(_b, ["stack"]);
        for (var _i = 0, _c = Object.keys(config.builders); _i < _c.length; _i++) {
            var name = _c[_i];
            var builderVal = config.builders[name];
            var builder = typeof builderVal === 'object' && builderVal.constructor !== Array ? __assign({}, builderVal) : { stack: builderVal };
            builder.name = name;
            builder.stack = new Stack_1.default(config.options.stack || [], typeof builder === 'object' ? builder.stack : builder);
            builder.roles = builder.roles || ['build', 'watch'];
            for (var _d = 0, _e = Object.keys(options); _d < _e.length; _d++) {
                var key = _e[_d];
                builder[key] = options[key];
            }
            builders[builder.name] = builder;
            builder.buildDir = builder.backendBuildDir || builder.frontendBuildDir ? undefined : 'build';
            builder.dllBuildDir = builder.dllBuildDir || 'build/dll';
            builder.webpackDll = builder.webpackDll !== undefined ? builder.webpackDll : true;
        }
        this.builders = builders;
        this.plugins = plugins.concat((config.plugins || []).map(function (name) { return new (require(name))(); }));
        var _a;
    }
    return ConfigRc;
}());
exports.default = ConfigRc;
//# sourceMappingURL=configRc.js.map